diff --git a/compiler/types/Coercion.lhs b/compiler/types/Coercion.lhs
index 251ab65..d771568 100644
--- a/compiler/types/Coercion.lhs
+++ b/compiler/types/Coercion.lhs
@@ -3,12 +3,6 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 -- | Module for (a) type kinds and (b) type coercions, 
 -- as used in System FC. See 'CoreSyn.Expr' for
@@ -26,13 +20,13 @@ module Coercion (
         isReflCo_maybe, coercionRole,
         mkCoercionType,
 
-	-- ** Constructing coercions
+        -- ** Constructing coercions
         mkReflCo, mkCoVarCo, 
         mkAxInstCo, mkUnbranchedAxInstCo, mkAxInstLHS, mkAxInstRHS,
         mkUnbranchedAxInstRHS,
         mkPiCo, mkPiCos, mkCoCast,
         mkSymCo, mkTransCo, mkNthCo, mkNthCoRole, mkLRCo,
-	mkInstCo, mkAppCo, mkTyConAppCo, mkFunCo,
+        mkInstCo, mkAppCo, mkTyConAppCo, mkFunCo,
         mkForAllCo, mkUnsafeCo, mkUnivCo, mkSubCo, mkPhantomCo,
         mkNewTypeCo, maybeSubCo, maybeSubCo2,
         mkAxiomRuleCo,
@@ -46,25 +40,25 @@ module Coercion (
         splitForAllCo_maybe,
         nthRole, tyConRolesX,
 
-	-- ** Coercion variables
-	mkCoVar, isCoVar, isCoVarType, coVarName, setCoVarName, setCoVarUnique,
+        -- ** Coercion variables
+        mkCoVar, isCoVar, isCoVarType, coVarName, setCoVarName, setCoVarUnique,
 
         -- ** Free variables
         tyCoVarsOfCo, tyCoVarsOfCos, coVarsOfCo, coercionSize,
-	
+        
         -- ** Substitution
         CvSubstEnv, emptyCvSubstEnv, 
- 	CvSubst(..), emptyCvSubst, Coercion.lookupTyVar, lookupCoVar,
-	isEmptyCvSubst, zapCvSubstEnv, getCvInScope,
+        CvSubst(..), emptyCvSubst, Coercion.lookupTyVar, lookupCoVar,
+        isEmptyCvSubst, zapCvSubstEnv, getCvInScope,
         substCo, substCos, substCoVar, substCoVars,
         substCoWithTy, substCoWithTys, 
-	cvTvSubst, tvCvSubst, mkCvSubst, zipOpenCvSubst,
+        cvTvSubst, tvCvSubst, mkCvSubst, zipOpenCvSubst,
         substTy, extendTvSubst,
         extendCvSubstAndInScope, extendTvSubstAndInScope,
-	substTyVarBndr, substCoVarBndr,
+        substTyVarBndr, substCoVarBndr,
 
-	-- ** Lifting
-	liftCoMatch, liftCoSubstTyVar, liftCoSubstWith, 
+        -- ** Lifting
+        liftCoMatch, liftCoSubstTyVar, liftCoSubstWith, 
         
         -- ** Comparison
         coreEqCoercion, coreEqCoercion2,
@@ -85,7 +79,7 @@ module Coercion (
 
 #include "HsVersions.h"
 
-import Unify	( MatchEnv(..), matchList )
+import Unify    ( MatchEnv(..), matchList )
 import TypeRep
 import qualified Type
 import Type hiding( substTy, substTyVarBndr, extendTvSubst )
@@ -96,15 +90,15 @@ import VarEnv
 import VarSet
 import Binary
 import Maybes   ( orElse )
-import Name	( Name, NamedThing(..), nameUnique, nameModule, getSrcSpan )
-import OccName 	( parenSymOcc )
+import Name     ( Name, NamedThing(..), nameUnique, nameModule, getSrcSpan )
+import OccName  ( parenSymOcc )
 import Util
 import BasicTypes
 import Outputable
 import Unique
 import Pair
 import SrcLoc
-import PrelNames	( funTyConKey, eqPrimTyConKey, eqReprPrimTyConKey )
+import PrelNames        ( funTyConKey, eqPrimTyConKey, eqReprPrimTyConKey )
 import Control.Applicative
 import Data.Traversable (traverse, sequenceA)
 import FastString
@@ -113,9 +107,9 @@ import qualified Data.Data as Data hiding ( TyCon )
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
             Coercions
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -153,9 +147,9 @@ data Coercion
   -- TyConAppCo :: "e" -> _ -> ?? -> e
   -- See Note [TyConAppCo roles]
   | TyConAppCo Role TyCon [Coercion]    -- lift TyConApp 
-    	       -- The TyCon is never a synonym; 
-	       -- we expand synonyms eagerly
-	       -- But it can be a type function
+               -- The TyCon is never a synonym; 
+               -- we expand synonyms eagerly
+               -- But it can be a type function
 
   | AppCo Coercion Coercion        -- lift AppTy
           -- AppCo :: e -> N -> e
@@ -491,9 +485,9 @@ necessary for soundness, but this choice removes ambiguity.
 The rules here also dictate what the parameters to mkTyConAppCo.
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Coercion variables}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -510,7 +504,7 @@ isCoVar :: Var -> Bool
 isCoVar v = isCoVarType (varType v)
 
 isCoVarType :: Type -> Bool
-isCoVarType ty 	    -- Tests for t1 ~# t2, the unboxed equality
+isCoVarType ty      -- Tests for t1 ~# t2, the unboxed equality
   = case splitTyConApp_maybe ty of
       Just (tc,tys) -> (tc `hasKey` eqPrimTyConKey || tc `hasKey` eqReprPrimTyConKey)
                        && tys `lengthAtLeast` 2
@@ -578,9 +572,9 @@ coercionSize (AxiomRuleCo _ tys cos) = 1 + sum (map typeSize tys)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
                             Tidying coercions
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -619,7 +613,7 @@ tidyCos env = map (tidyCo env)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
                    Pretty-printing coercions
 %*                                                                      *
 %************************************************************************
@@ -749,9 +743,9 @@ pprCoAxBranchHdr ax@(CoAxiom { co_ax_tc = fam_tc, co_ax_name = name }) index
 \end{code}
 
 %************************************************************************
-%*									*
-	Functions over Kinds		
-%*									*
+%*                                                                      *
+        Functions over Kinds            
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -830,9 +824,9 @@ isReflCo_maybe _                 = Nothing
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
             Building coercions
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -924,12 +918,12 @@ mkAppCos co1 cos = foldl mkAppCo co1 cos
 -- caller's responsibility to get the roles correct on argument coercions.
 mkTyConAppCo :: Role -> TyCon -> [Coercion] -> Coercion
 mkTyConAppCo r tc cos
-	       -- Expand type synonyms
+               -- Expand type synonyms
   | Just (tv_co_prs, rhs_ty, leftover_cos) <- tcExpandTyCon_maybe tc cos
   = mkAppCos (liftCoSubst r tv_co_prs rhs_ty) leftover_cos
 
   | Just tys <- traverse isReflCo_maybe cos 
-  = Refl r (mkTyConApp tc tys)	-- See Note [Refl invariant]
+  = Refl r (mkTyConApp tc tys)  -- See Note [Refl invariant]
 
   | otherwise = TyConAppCo r tc cos
 
@@ -1144,9 +1138,9 @@ mkCoCast c g
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
             Newtypes
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -1202,7 +1196,7 @@ topNormaliseNewTypeX _ _ = Nothing
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
                    Equality of coercions
 %*                                                                      *
 %************************************************************************
@@ -1259,7 +1253,7 @@ coreEqCoercion2 _ _ _ = False
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
                    Substitution of coercions
 %*                                                                      *
 %************************************************************************
@@ -1272,17 +1266,17 @@ type CvSubstEnv = VarEnv Coercion
 emptyCvSubstEnv :: CvSubstEnv
 emptyCvSubstEnv = emptyVarEnv
 
-data CvSubst 		
-  = CvSubst InScopeSet 	-- The in-scope type variables
-	    TvSubstEnv	-- Substitution of types
+data CvSubst            
+  = CvSubst InScopeSet  -- The in-scope type variables
+            TvSubstEnv  -- Substitution of types
             CvSubstEnv  -- Substitution of coercions
 
 instance Outputable CvSubst where
   ppr (CvSubst ins tenv cenv)
     = brackets $ sep[ ptext (sLit "CvSubst"),
-		      nest 2 (ptext (sLit "In scope:") <+> ppr ins), 
-		      nest 2 (ptext (sLit "Type env:") <+> ppr tenv),
-		      nest 2 (ptext (sLit "Coercion env:") <+> ppr cenv) ]
+                      nest 2 (ptext (sLit "In scope:") <+> ppr ins), 
+                      nest 2 (ptext (sLit "Type env:") <+> ppr tenv),
+                      nest 2 (ptext (sLit "Coercion env:") <+> ppr cenv) ]
 
 emptyCvSubst :: CvSubst
 emptyCvSubst = CvSubst emptyInScopeSet emptyVarEnv emptyVarEnv
@@ -1335,8 +1329,8 @@ substCoVarBndr subst@(CvSubst in_scope tenv cenv) old_var
 
     new_var = uniqAway in_scope subst_old_var
     subst_old_var = mkCoVar (varName old_var) (substTy subst (varType old_var))
-		  -- It's important to do the substitution for coercions,
-		  -- because they can have free type variables
+                  -- It's important to do the substitution for coercions,
+                  -- because they can have free type variables
 
 substTyVarBndr :: CvSubst -> TyVar -> (CvSubst, TyVar)
 substTyVarBndr (CvSubst in_scope tenv cenv) old_var
@@ -1426,9 +1420,9 @@ lookupCoVar (CvSubst _ _ cenv) v = lookupVarEnv cenv v
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
                    "Lifting" substitution
-	   [(TyVar,Coercion)] -> Type -> Coercion
+           [(TyVar,Coercion)] -> Type -> Coercion
 %*                                                                      *
 %************************************************************************
 
@@ -1508,8 +1502,8 @@ ty_co_subst subst role ty
     go Phantom ty             = lift_phantom ty
     go role (TyVarTy tv)      = liftCoSubstTyVar subst role tv
                                 `orElse` Refl role (TyVarTy tv)
-       			     -- A type variable from a non-cloned forall
-			     -- won't be in the substitution
+                             -- A type variable from a non-cloned forall
+                             -- won't be in the substitution
     go role (AppTy ty1 ty2)   = mkAppCo (go role ty1) (go Nominal ty2)
     go role (TyConApp tc tys) = mkTyConAppCo role tc
                                            (zipWith go (tyConRolesX role tc) tys)
@@ -1556,10 +1550,10 @@ liftCoSubstTyVar (LCS _ cenv) r tv
 
 liftCoSubstTyVarBndr :: LiftCoSubst -> TyVar -> (LiftCoSubst, TyVar)
 liftCoSubstTyVarBndr subst@(LCS in_scope cenv) old_var
-  = (LCS (in_scope `extendInScopeSet` new_var) new_cenv, new_var)		
+  = (LCS (in_scope `extendInScopeSet` new_var) new_cenv, new_var)               
   where
     new_cenv | no_change = delVarEnv cenv old_var
-	     | otherwise = extendVarEnv cenv old_var (Refl Nominal (TyVarTy new_var))
+             | otherwise = extendVarEnv cenv old_var (Refl Nominal (TyVarTy new_var))
 
     no_change = no_kind_change && (new_var == old_var)
 
@@ -1643,7 +1637,7 @@ ty_co_match menv cenv (TyVarTy tv1) co
 
   | otherwise    -- tv1 is not a template ty var, so the only thing it
                  -- can match is a reflexivity coercion for itself.
-		 -- But that case is dealt with already
+                 -- But that case is dealt with already
   = Nothing
 
   where
@@ -1651,7 +1645,7 @@ ty_co_match menv cenv (TyVarTy tv1) co
     tv1' = rnOccL rn_env tv1
 
 ty_co_match menv subst (AppTy ty1 ty2) co
-  | Just (co1, co2) <- splitAppCo_maybe co	-- c.f. Unify.match on AppTy
+  | Just (co1, co2) <- splitAppCo_maybe co      -- c.f. Unify.match on AppTy
   = do { subst' <- ty_co_match menv subst ty1 co1 
        ; ty_co_match menv subst' ty2 co2 }
 
@@ -1685,9 +1679,9 @@ pushRefl _                          = Nothing
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
             Sequencing on coercions
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -1714,9 +1708,9 @@ seqCos (co:cos) = seqCo co `seq` seqCos cos
 
 
 %************************************************************************
-%*									*
-	     The kind of a type, and of a coercion
-%*									*
+%*                                                                      *
+             The kind of a type, and of a coercion
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
diff --git a/compiler/types/Kind.lhs b/compiler/types/Kind.lhs
index 793aa4a..0714625 100644
--- a/compiler/types/Kind.lhs
+++ b/compiler/types/Kind.lhs
@@ -3,19 +3,13 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module Kind (
         -- * Main data type
         SuperKind, Kind, typeKind,
 
-	-- Kinds
-	anyKind, liftedTypeKind, unliftedTypeKind, openTypeKind, constraintKind,
+        -- Kinds
+        anyKind, liftedTypeKind, unliftedTypeKind, openTypeKind, constraintKind,
         mkArrowKind, mkArrowKinds,
 
         -- Kind constructors...
@@ -23,9 +17,9 @@ module Kind (
         unliftedTypeKindTyCon, constraintKindTyCon,
 
         -- Super Kinds
-	superKind, superKindTyCon, 
+        superKind, superKindTyCon, 
         
-	pprKind, pprParendKind,
+        pprKind, pprParendKind,
 
         -- ** Deconstructing Kinds
         kindAppResult, synTyConResKind,
@@ -65,9 +59,9 @@ import Util
 \end{code}
 
 %************************************************************************
-%*									*
-	Functions over Kinds		
-%*									*
+%*                                                                      *
+        Functions over Kinds            
+%*                                                                      *
 %************************************************************************
 
 Note [Kind Constraint and kind *]
@@ -204,7 +198,7 @@ isSubOpenTypeKindKey uniq
   || uniq == constraintKindTyConKey  -- Needed for error (Num a) "blah"
                                      -- and so that (Ord a -> Eq a) is well-kinded
                                      -- and so that (# Eq a, Ord b #) is well-kinded
-                              	     -- See Note [Kind Constraint and kind *]
+                                     -- See Note [Kind Constraint and kind *]
 
 -- | Is this a kind (i.e. a type-of-types)?
 isKind :: Kind -> Bool
@@ -279,11 +273,11 @@ defaultKind_maybe :: Kind -> Maybe Kind
 -- simple (* or *->* etc).  So generic type variables (other than
 -- built-in constants like 'error') always have simple kinds.  This is important;
 -- consider
---	f x = True
+--      f x = True
 -- We want f to get type
---	f :: forall (a::*). a -> Bool
+--      f :: forall (a::*). a -> Bool
 -- Not 
---	f :: forall (a::ArgKind). a -> Bool
+--      f :: forall (a::ArgKind). a -> Bool
 -- because that would allow a call like (f 3#) as well as (f True),
 -- and the calling conventions differ.
 -- This defaulting is done in TcMType.zonkTcTyVarBndr.
diff --git a/compiler/types/OptCoercion.lhs b/compiler/types/OptCoercion.lhs
index ebc2cbe..5598575 100644
--- a/compiler/types/OptCoercion.lhs
+++ b/compiler/types/OptCoercion.lhs
@@ -3,12 +3,6 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module OptCoercion ( optCoercion, checkAxInstCo ) where 
 
@@ -23,7 +17,7 @@ import Var
 import VarSet
 import FamInstEnv   ( flattenTys )
 import VarEnv
-import StaticFlags	( opt_NoOptCoercion )
+import StaticFlags      ( opt_NoOptCoercion )
 import Outputable
 import Pair
 import Maybes
@@ -36,7 +30,7 @@ import InstEnv
 
 %************************************************************************
 %*                                                                      *
-                 Optimising coercions									
+                 Optimising coercions                                                                   
 %*                                                                      *
 %************************************************************************
 
@@ -75,11 +69,11 @@ type NormalCo = Coercion
 type NormalNonIdCo = NormalCo  -- Extra invariant: not the identity
 
 opt_co, opt_co' :: CvSubst
-       		-> Bool	       -- True <=> return (sym co)
+                -> Bool        -- True <=> return (sym co)
                 -> Maybe Role  -- Nothing <=> don't change; otherwise, change
                                -- INVARIANT: the change is always a *downgrade*
-       		-> Coercion
-       		-> NormalCo	
+                -> Coercion
+                -> NormalCo     
 opt_co = opt_co' 
 {-
 opt_co env sym co
@@ -424,7 +418,7 @@ opt_trans_rule is co1 co2
     co2_is_axiom_maybe = isAxiom_maybe co2
     role = coercionRole co1 -- should be the same as coercionRole co2!
 
-opt_trans_rule _ co1 co2	-- Identity rule
+opt_trans_rule _ co1 co2        -- Identity rule
   | Pair ty1 _ <- coercionKind co1
   , Pair _ ty2 <- coercionKind co2
   , ty1 `eqType` ty2
@@ -540,7 +534,7 @@ matchAxiom sym ax@(CoAxiom { co_ax_tc = tc }) ind co
 compatible_co :: Coercion -> Coercion -> Bool
 -- Check whether (co1 . co2) will be well-kinded
 compatible_co co1 co2
-  = x1 `eqType` x2		
+  = x1 `eqType` x2              
   where
     Pair _ x1 = coercionKind co1
     Pair x2 _ = coercionKind co2
